﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace IEnumerableImplementation {

	class A : IEnumerable<int> {
		public IEnumerator<int> GetEnumerator() {
			return new AEnumerator();
		}

		IEnumerator IEnumerable.GetEnumerator() {
			return this.GetEnumerator();
		}

		private class AEnumerator : IEnumerator<int> {
			public int Current { get; private set; }

			object IEnumerator.Current {
				get {
					return this.Current;
				}
			}

			public void Dispose() {
			}

			public bool MoveNext() {
				if (Current <= 5) {
					Current++;
					Console.WriteLine("AEnumerator.MoveNext() -> true");
					return true;
				} else {
					Console.WriteLine("AEnumerator.MoveNext() -> false");
					return false;
				}
			}

			public void Reset() {
				Current = 0;
			}
		}
	}

	class Program {
		static void Main(string[] args) {
			var a = new A();

			Console.WriteLine("before foreach");
			foreach (var i in a) {
				Console.WriteLine(i);
			}
			Console.WriteLine("after foreach");
		}
	}
}
